unit Display;

interface

procedure HideCursor;					{   }
procedure ShowCursor;					{   }
procedure SetCharMap( Code: byte );			{ ⠭  ᨬ }
procedure GetFontEGA( AddrFont: pointer; Tall: word );	{    ᨬ ⥪饣 䮭 }
procedure SetFontEGA( AddrFont: pointer; Tall: word );	{    ᨬ  ⥪騩 䮭 }
procedure SetNewSymbol( Map: pointer; Code: byte; Tall: word );

implementation

var
  SizeCursor: word;

procedure HideCursor; assembler;
asm
	mov	ah,3
	mov     bh,0
	int	10h		{  ࠧ  न  }
	mov	SizeCursor,cx	{ ࠭ ࠧ  }
	mov	ah,1
	mov	ch,20h
	int	10h		{   }
end;

procedure ShowCursor; assembler;
asm
	mov	ah,1
	mov	cx,SizeCursor
	int	10h		{ ⠭ ࠧ  }
end;

procedure SetCharMap; assembler;
asm
	mov	ax,1103h
	mov	bl,Code		{  0,1 -    ⥭ᨢ }
				{  2,3 -   ᮪ ⥭ᨢ }
	int	10h		{ ⠭  ᨬ }
end;

procedure SpecialAccess; assembler;
asm
	mov	dx,3C4h
	mov	ax,402h
	out	dx,ax
	mov	ax,704h
	out	dx,ax
	mov	dx,3CEh
	mov	ax,5
	out	dx,ax
	mov	ax,6
	out	dx,ax
	mov	ax,204h
	out	dx,ax
end;

procedure NormalAccess; assembler;
asm
	mov	dx,3C4h
	mov	ax,304h
	out	dx,ax
	mov	ax,302h
	out	dx,ax
	mov	dx,3CEh
	mov	ax,1005h
	out	dx,ax
	mov	ax,0E06h
	out	dx,ax
	mov	ax,4
	out	dx,ax
end;

procedure GetFontEGA; assembler;
asm
	push	ds
	cld
	les	di,AddrFont
	mov	ax,0A000h
	mov	ds,ax
	xor	si,si
	call	SpecialAccess
@1:	mov	cx,Tall
	rep movsb
	and	si,0FFE0h
	add	si,32		{ 32    }
	cmp	si,2000h	{ ᫮   ⠡  ᨬ }
	jne @1
	call	NormalAccess
	pop	ds
end;

procedure SetFontEGA; assembler;
asm
	push	ds
	cld
	lds	si,AddrFont
	mov	ax,0A000h
	mov	es,ax
	xor	di,di
	call	SpecialAccess
@1:	mov	cx,Tall		{  ᨬ }
	rep movsb
	and	di,0FFE0h
	add	di,32		{ 32    }
	cmp	di,2000h	{ ᫮   ⠡  ᨬ }
	jne @1
	call	NormalAccess
	pop	ds
end;

procedure SetNewSymbol; assembler;
asm
	push	ds
	cld
	mov	ax,0A000h
	mov	es,ax
	mov	cl,Code
	mov	ch,2
	mov	di,cx
	shl	di,5
	lds	si,Map
	mov	cx,Tall
	call	SpecialAccess
	rep movsb
	call	NormalAccess
	pop	ds
end;
end.